/*******************************************/
/*      Definitioner                       */
/*******************************************/

/*************************************************************************
*               R E V I S I O N   H I S T O R Y                       
*                         Release 0
*
* Rev #    Date        Modifications/Corrections for new Revision
* -----  ---------     ---------------------------------------------------
*  0.01    930818      Ported from Atari to Unix on Sun
*
*  0.02    941019   1. files asm03man.c and asm03ma2.c concatenated.
*                   2. tabs replaced with spaces.
*
*  0.03    970314   1. Version printout added.
*
*  0.04    970320   1. A space added after every mnem.
*
*
*/
static char *version = "asm03tbl 0.04  970320";

#include <stdio.h>

#include "asmdef.h"

char *tblversion()
{

    return version;
}

#define CPU01   1
#define CPU00   2
#define HD6303  4

/*tables */

CPUTYPE cputab[] = {
    "6301", HD6303,
    "6303", HD6303,
    "HD6301", HD6303,
    "HD6303", HD6303,
    "6800", CPU00,
    "6801", CPU01,
    "6803", CPU01,
    "MC6800", CPU00,
    "MC6801", CPU01,
    "MC6803", CPU01,
    "00", CPU00,
    "01", CPU01,
    "03", CPU01,
    "", 0
};

short pagetab[1];

short adrcnv[] = { /* for optypes, contents: mask  */
    0x0000,     /* 0 */
    0x0001,     /* 1 INH    NOP  inh                */
    0x0074,     /* 2 IMM8   ADDA  imm8, dir,ind,ext */
    0x0078,     /* 3 IMM16  ADDD  imm16,dir,ind,ext */
    0x0060,     /* 4 NODIR  CLR             ind,ext */
    0x0070,     /* 5 NOIMM  STAA        dir,ind,ext */
    0x0000,     /* 6 */
    0x0002,     /* 7 REL    BRA  rel                */
    0x0000,     /* 8 */
    0x0001,     /* 9 IMMADR AIM  imm,ind/dir      (HD6301) */
};

AdrType adrtab[] = { /* contents: reserved, mask, addval, length  */
    0, 0x0001, 0x00, 1,    /* 0 inh */
    0, 0x0002, 0x00, 2,    /* 1 rel */
    0, 0x0004, 0x00, 2,    /* 2 imm8 */
    0, 0x0008, 0x00, 3,    /* 3 imm16 */
    0, 0x0010, 0x10, 2,    /* 4 dir */
    0, 0x0020, 0x30, 3,    /* 5 ext */
    0, 0x0040, 0x20, 2,    /* 6 ind */
    0, 0x0001, 0x20, 3,    /* 7 immind */
    0, 0x0001, 0x30, 3,    /* 8 immdir */
};

MneType mnemic[] = { /* contents: mnemonic, basic opcode, type, cpu */
    "ABA ",  0x1B, INH, 0,
    "ABX ",  0x3A, INH, CPU01 | HD6303,
    "ADCA ", 0x89, MNEREADOP | IMM8, 0,
    "ADCB ", 0xC9, MNEREADOP | IMM8, 0,
    "ADDA ", 0x8B, MNEREADOP | IMM8, 0,
    "ADDB ", 0xCB, MNEREADOP | IMM8, 0,
    "ADDD ", 0xC3, MNEREADOP | IMM16, CPU01 | HD6303,
    "AIM ",  0x41, IMMADR, HD6303,
    "ALIGN ", AD_ALIG, ASMDIR, 0,
    "ANDA ", 0x84, MNEREADOP | IMM8, 0,
    "ANDB ", 0xC4, MNEREADOP | IMM8, 0,
    "ASL ",  0x48, MNEMODIFYOP | NODIR, 0,
    "ASLA ", 0x48, INH, 0,
    "ASLB ", 0x58, INH, 0,
    "ASLD ", 0x05, INH, CPU01 | HD6303,
    "ASR ",  0x47, MNEMODIFYOP | NODIR, 0,
    "ASRA ", 0x47, INH, 0,
    "ASRB ", 0x57, INH, 0,
    "BCC ",  0x24, MNEREADOP | REL, 0,
    "BCS ",  0x25, MNEREADOP | REL, 0,
    "BEQ ",  0x27, MNEREADOP | REL, 0,
    "BGE ",  0x2C, MNEREADOP | REL, 0,
    "BGT ",  0x2E, MNEREADOP | REL, 0,
    "BHI ",  0x22, MNEREADOP | REL, 0,
    "BHS ",  0x24, MNEREADOP | REL, 0,
    "BITA ", 0x85, MNEREADOP | IMM8, 0,
    "BITB ", 0xC5, MNEREADOP | IMM8, 0,
    "BLE ",  0x2F, MNEREADOP | REL, 0,
    "BLO ",  0x25, MNEREADOP | REL, 0,
    "BLS ",  0x23, MNEREADOP | REL, 0,
    "BLT ",  0x2D, MNEREADOP | REL, 0,
    "BMI ",  0x2B, MNEREADOP | REL, 0,
    "BNE ",  0x26, MNEREADOP | REL, 0,
    "BPL ",  0x2A, MNEREADOP | REL, 0,
    "BRA ",  0x20, MNEREADOP | REL, 0,
    "BRN ",  0x21, MNEREADOP | REL, CPU01 | HD6303,
    "BSR ",  0x8D, MNEREADOP | REL, 0,
    "BVC ",  0x28, MNEREADOP | REL, 0,
    "BVS ",  0x29, MNEREADOP | REL, 0,
    "CBA ",  0x11, INH, 0,
    "CLC ",  0x0C, INH, 0,
    "CLI ",  0x0E, INH, 0,
    "CLR ",  0x4F, MNEMODIFYOP | NODIR, 0,
    "CLRA ", 0x4F, INH, 0,
    "CLRB ", 0x5F, INH, 0,
    "CLV ",  0x0A, INH, 0,
    "CMPA ", 0x81, MNEREADOP | IMM8, 0,
    "CMPB ", 0xC1, MNEREADOP | IMM8, 0,
    "CMPX ", 0x8C, MNEREADOP | IMM16, 0,
    "COM ",  0x43, MNEMODIFYOP | NODIR, 0,
    "COMA ", 0x43, INH, 0,
    "COMB ", 0x53, INH, 0,
    "CPU ",  AD_CPU, ASMDIR, 0,
    "CPX ",  0x8C, MNEREADOP | IMM16, 0,
    "DAA ",  0x19, INH, 0,
    "DATA ", AD_DATA, ASMDIR, 0,
    "DEC ",  0x4A, MNEMODIFYOP | NODIR, 0,
    "DECA ", 0x4A, INH, 0,
    "DECB ", 0x5A, INH, 0,
    "DES ",  0x34, INH, 0,
    "DEX ",  0x09, INH, 0,
    "EIM ",  0x45, IMMADR, HD6303,
    "END ",  AD_END, ASMDIR, 0,
    "EORA ", 0x88, MNEREADOP | IMM8, 0,
    "EORB ", 0xC8, MNEREADOP | IMM8, 0,
    "EQU ",  AD_EQU, ASMDIR, 0,
    "FCB ",  AD_FCB, ASMDIR, 0,
    "FCC ",  AD_FCC, ASMDIR, 0,
    "FDB ",  AD_FDB, ASMDIR, 0,
    "FQB ",  AD_FQB, ASMDIR, 0,
    "INC ",  0x4C, MNEMODIFYOP | NODIR, 0,
    "INCA ", 0x4C, INH, 0,
    "INCB ", 0x5C, INH, 0,
    "INCL",  AD_INCL, ASMDIR, 0,
    "INS ",  0x31, INH, 0,
    "INX ",  0x08, INH, 0,
    "JMP ",  0x4E, MNEJUMP | MNEREADOP | NODIR, 0,
    "JSR ",  0x8D, MNEJUMP | MNEREADOP | NODIR, CPU00,
    "JSR ",  0x8D, MNEJUMP | MNEREADOP | NOIMM, CPU01 | HD6303,
    "LDA ",  0x86, MNEREADOP | IMM8, 0,
    "LDAA ", 0x86, MNEREADOP | IMM8, 0,
    "LDAB ", 0xC6, MNEREADOP | IMM8, 0,
    "LDB ",  0xC6, MNEREADOP | IMM8, 0,
    "LDD ",  0xCC, MNEREADOP | IMM16, CPU01 | HD6303,
    "LDS ",  0x8E, MNEREADOP | IMM16, 0,
    "LDX ",  0xCE, MNEREADOP | IMM16, 0,
    "LSL ",  0x48, MNEMODIFYOP | NODIR, 0,
    "LSLA ", 0x48, INH, 0,
    "LSLB ", 0x58, INH, 0,
    "LSLD ", 0x05, INH, CPU01 | HD6303,
    "LSR ",  0x44, MNEMODIFYOP | NODIR, 0,
    "LSRA ", 0x44, INH, 0,
    "LSRB ", 0x54, INH, 0,
    "LSRD ", 0x04, INH, CPU01 | HD6303,
    "MUL ",  0x3D, INH, CPU01 | HD6303,
    "NEG ",  0x40, MNEMODIFYOP | NODIR, 0,
    "NEGA ", 0x40, INH, 0,
    "NEGB ", 0x50, INH, 0,
    "NOP ",  0x01, INH, 0,
    "OIM ",  0x42, IMMADR, HD6303,
    "OPT ",  AD_OPT, ASMDIR, 0,
    "ORA ",  0x8A, MNEREADOP | IMM8, 0,
    "ORAA ", 0x8A, MNEREADOP | IMM8, 0,
    "ORAB ", 0xCA, MNEREADOP | IMM8, 0,
    "ORB ",  0xCA, MNEREADOP | IMM8, 0,
    "ORG ",  AD_ORG, ASMDIR, 0,
    "PAGE ", AD_PAGE, ASMDIR, 0,
    "PSHA ", 0x36, INH, 0,
    "PSHB ", 0x37, INH, 0,
    "PSHX ", 0x3C, INH, CPU01 | HD6303,
    "PULA ", 0x32, INH, 0,
    "PULB ", 0x33, INH, 0,
    "PULX ", 0x38, INH, CPU01 | HD6303,
    "RMB ",  AD_RMB, ASMDIR, 0,
    "ROL ",  0x49, MNEMODIFYOP | NODIR, 0,
    "ROLA ", 0x49, INH, 0,
    "ROLB ", 0x59, INH, 0,
    "ROR ",  0x46, MNEMODIFYOP | NODIR, 0,
    "RORA ", 0x46, INH, 0,
    "RORB ", 0x56, INH, 0,
    "RTI ",  0x3B, INH, 0,
    "RTS ",  0x39, INH, 0,
    "SBA ",  0x10, INH, 0,
    "SBCA ", 0x82, MNEREADOP | IMM8, 0,
    "SBCB ", 0xC2, MNEREADOP | IMM8, 0,
    "SEC ",  0x0D, INH, 0,
    "SEI ",  0x0F, INH, 0,
    "SEV ",  0x0B, INH, 0,
    "SLP ",  0x1A, INH, HD6303,
    "STA ",  0x87, MNEWRITEOP | NOIMM, 0,
    "STAA ", 0x87, MNEWRITEOP | NOIMM, 0,
    "STAB ", 0xC7, MNEWRITEOP | NOIMM, 0,
    "STB ",  0xC7, MNEWRITEOP | NOIMM, 0,
    "STD ",  0xCD, MNEWRITEOP | NOIMM, CPU01 | HD6303,
    "STS ",  0x8F, MNEWRITEOP | NOIMM, 0,
    "STX ",  0xCF, MNEWRITEOP | NOIMM, 0,
    "SUBA ", 0x80, MNEREADOP | IMM8, 0,
    "SUBB ", 0xC0, MNEREADOP | IMM8, 0,
    "SUBD ", 0x83, MNEREADOP | IMM16, CPU01 | HD6303,
    "SWI ",  0x3F, INH, 0,
    "TAB ",  0x16, INH, 0,
    "TAP ",  0x06, INH, 0,
    "TBA ",  0x17, INH, 0,
    "TEXT ", AD_TEXT, ASMDIR, 0,
    "TIM ",  0x4B, IMMADR, HD6303,
    "TPA ",  0x07, INH, 0,
    "TST ",  0x4D, MNEREADOP | NODIR, 0,
    "TSTA ", 0x4D, INH, 0,
    "TSTB ", 0x5D, INH, 0,
    "TSX ",  0x30, INH, 0,
    "TTL ",  AD_TTL, ASMDIR, 0,
    "TXS ",  0x35, INH, 0,
    "WAI ",  0x3E, INH, 0,
    "XGDX ", 0x18, INH, HD6303,
    ".ERR",  AD_ERROR, ASMDIR, 0,
    ".WARN", AD_WARN, ASMDIR, 0,
    "*",  0,  -1, 0,
    "",  0,  -1, 0
};

/*
 * Old 6800 assemblers allowed a space (or maybe more) before the register
 * specification, this table is included in a hack to take care of that.
 *
 */
MneFix mnefixtbl[] = {
    { "ADC ", "AB" },
    { "ADD ", "AB" },
    { "AND ", "AB" },
    { "ASL ", "AB" },
    { "ASR ", "AB" },
    { "BIT ", "AB" },
    { "CLR ", "AB" },
    { "CMP ", "AB" },
    { "COM ", "AB" },
    { "DEC ", "AB" },
    { "EOR ", "AB" },
    { "INC ", "AB" },
    { "LDA ", "AB" },
    { "LSL ", "AB" },
    { "LSR ", "AB" },
    { "NEG ", "AB" },
    { "ORA ", "AB" },
    { "PSH ", "AB" },
    { "PUL ", "AB" },
    { "ROL ", "AB" },
    { "ROR ", "AB" },
    { "SBC ", "AB" },
    { "STA ", "AB" },
    { "SUB ", "AB" },
    { "TST ", "AB" },
    {"", ""}
};

unsigned short mnemiccnttab[sizeof(mnemic)/sizeof(MneType)];

long getmnemicsize()
{

   return sizeof(mnemic);
}

/* end */
