/*******************************************/
/*      Definitioner                       */
/*******************************************/

/*************************************************************************
*               R E V I S I O N   H I S T O R Y                       
*                         Release 0
*
* Rev #    Date        Modifications/Corrections for new Revision
* -----  ---------     ---------------------------------------------------
*  0.01    930818      Ported to Unix on Sun
*
*  0.02    941019   1. files asm03man.c and asm03ma2.c concatenated,
*                       asmcom.c created.
*                   2. tabs replaced with spaces.
*
*  0.03    970314   1. New output formats: Motorola S-rec, Intel hex and
*                       prepared for Tectronics hex.
*                   2. Lots of new command line options added to support
*                       the new format and to specify the output file names.
*
*  0.04    120517   1. Possible to set prio of * same as +
*
*/

#include <stdio.h>

#define ASMDEF_C
char *defversion = "asmdef   0.04  2012-05-17";
#include "asmdef.h"

/* Error codes , warning start with W, error with E, information with I */

char *errstr[] = {
    "EAddressing mode is not allowed",              /* 0 */
    "WValue exceeds available field width",         /* 1 */
    "EOffset in branch out of range",               /* 2 */
    "ESymbol/macro double defined",                 /* 3 */
    "ESymbol name is illegal",                      /* 4 */
    "EUnrecognised mnemonic",                       /* 5 */
    "EValue is not a binary number",                /* 6 */
    "EValue is not a hex number",                   /* 7 */
    "EEnd parentes is missing",                     /* 8 */
    "ESymbols must be defined before this stmt.",   /* 9 */
    "ENo expression in address field",              /* 10 */
    "ESymbol is not defined",                       /* 11 */
    "EUnrecognised option",                         /* 12 */
    "EAddress in ORG is in old area",               /* 13 */
    "EFunction not yet implemented",                /* 14 */
    "ENot allowed in data segment",                 /* 15 */
    "EToo many open files",                         /* 16 */
    "ECannot Open File",                            /* 17 */
    "EUnknown or missing register specification",   /* 18 */
    "WShort branch can be used",                    /* 19 */
    "Evalue out of range",                          /* 20 */
    "EString constant not terminated",              /* 21 */
    "EBase out of range",                           /* 22 */
    "ENot a valid number",                          /* 23 */
    "ILong branch offset is near short range",      /* 24 */
    "IBranch over branch",                          /* 25 */
    "IShort branch changed to long",                /* 26 */
    "ILong branch changed to short",                /* 27 */
    "EDivide by zero",                              /* 28 */
    "EENDC/ELSE without IF",                        /* 29 */
    "EMissing ENDC",                                /* 30 */
    "EMissing ENDM",                                /* 31 */
    "ELabelstack under/overflow",                   /* 32 */
    "EMissing .POP",                                /* 33 */
    "SENested definition of macro or struct",       /* 34 */
    "IInstruction optimized away",                  /* 35 */
    "FFatal error",                                 /*  */
    "FFatal error",                                 /*  */
    "FFatal error",                                 /*  */
};


/* variables */

FILE *hdl_asm;      // asm input
FILE *hdl_bin;      // bin output
FILE *hdl_lst;      // list file output
FILE *hdl_err;      // error file output
FILE *hdl_scr;      // console (screen) output
long adr;
long prgcnt;
long prgcntdata;
long prgcnttext;
int prgmode;
SECTION *textsection;
SECTION *datasection;
SECTION *cursection;



long structprgcnt;
int structdef;

long symbolptr;
long startadr;
long runadr;

long errstrtab[13];

int xreflist;           /* xref in output */
int statistics;         /* include assembler statistics */
int adrsizcnt;
int page, pagelen;
int linelen;
int line;             /* line number */
int prntline;         /* line number to print out */
int pass;             /* pass count */
int errcnt;           /* number of errors */
int errlinelow;       /* first line with error */
int errline;          /* highest line with error */
int wrncnt;           /* number of warnings */
int wrnlinelow;       /* first line with warning */
int wrnline;          /* highest line with warning */
int infocnt;          /* number of informations */
int infolinelow;      /* first line with info */
int infoline;         /* highest line with info */

int optimizebranch;
int noforwardopt;
int lbwrn;
int lblflag;
int aflag;
int dflag;
int rflag;
int endoffil;
int listflag;
int exprflag;
int txtptr;
int errpos;
int txtstart;
int opcode;
int optype;
int oplen;
int len;
int opref;
int opclen;
int errpostab[11];
int errcodtab[11];
int bufptr;
int bufflg;
int symbmaxlen;
int mulnoprio = 0;

char *cmd;
char *cmdbase;
char txt[200];
char mnesav[12];
char txtout[200];
char errout[200];
char title[64];
char sel[16];
char path[32];
char buftab[MAXBUFLEN];

char lstfilename[64];
char objfilename[64];
FILE_S files[MAXOPENFILE];
int  actfile;
int objfileformat;
int mnemiccnt, mnedircnt;
int cputypemask;

unsigned char adrsiztab[10000];
unsigned char dta[10000];  /* output data to bin-file */
unsigned char pdta[10];  /* print data if different from output data */

/* end */
