/*****************************************/
/*  File handling                        */
/*****************************************/

/*************************************************************************
*               R E V I S I O N   H I S T O R Y                       
*                         Release 0
*
* Rev #    Date        Modifications/Corrections for new Revision
* -----  ---------     ---------------------------------------------------
*  0.01    930818      Ported from Atari to Unix on Sun
*
*  0.02    941019   1. files asm03man.c and asm03ma2.c concatenated,
*                       asmcom.c created.
*                   2. tabs replaced with spaces.
*
*  0.03    970314   1. New output formats: Motorola S-rec, Intel hex and
*                       prepared for Tectronics hex.
*                   2. Version printout added.
*
*
*/
static char *version = "asmfil   0.03  970314";

/* #include <gemdefs.h> */
/* #include <obdefs.h>  */
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "asmdef.h"

char *filversion()
{

    return version;
}

void close_files()
{

   if (hdl_asm) {
       fclose(hdl_asm);
       hdl_asm = 0;
   }

   if (hdl_bin) {
       fclose(hdl_bin);
       hdl_bin = 0;
   }

   if (hdl_lst && hdl_lst != hdl_scr) {
       fclose(hdl_lst);
       hdl_lst = 0;
   }

   if (hdl_err && hdl_err != hdl_scr) {
       fclose(hdl_err);
       hdl_err = 0;
   }

}

FILE *open_inclfile(char *name)
{

   return opfi(name, "r", "");
}

int open_infile(char *name)
{
   char *s;

   if (hdl_asm) {
       fclose(hdl_asm);
   }

   if (!(hdl_asm = opfi(name, "r", ""))) {
         return 0;
   }

   return 1;
}

int open_outfile(char *name)
{
    char *p;
    char on[200]; /* out name */

    strcpy(on, name);
    p = strrchr(on, '.');   // cut off ext
    if (p) {
        *p = 0;
    }

    if (pass == LAST_PASS) {
        if (objfilename[0]) {
            hdl_bin = opfi(objfilename, "w", "");
        }
        else if (objfileformat == S19OBJ) {
            hdl_bin = opfi(on, "w", "s19");
        }
        else {
            hdl_bin = opfi(on, "w", "obj");
        }

        switch (listflag) {
        case 0:
            hdl_lst = 0;
            break;
        case 1:
            hdl_lst = stdout;
            break;
        case 2:
            if (lstfilename[0]) {
                hdl_lst = opfi(lstfilename, "w", "");
            }
            else {
                hdl_lst = opfi(on, "w", "lst");
            }
            break;
        }

        if (listflag == 1) {
            hdl_err = 0;
        }
        else {
            hdl_err = stdout;
        }
    }
    return 1;
}

int open_listfile(char *name)
{
    char *p;
    char on[200]; /* out name */

    strcpy(on, name);
    p = strrchr(on, '.');   // cut off ext
    if (p) {
        *p = 0;
    }

    switch (listflag) {
    case 0:
        hdl_lst = 0;
        break;
    case 1:
        hdl_lst = stdout;
        break;
    case 2:
        if (lstfilename[0]) {
            hdl_lst = opfi(lstfilename, "w", "");
        }
        else {
            hdl_lst = opfi(on, "w", "lst");
        }
        break;
    }

    if (listflag == 1) {
        hdl_err = 0;
    }
    else {
        hdl_err = stdout;
    }
    return 1;
}

void getfname(char *f, char *n, char *e)
{

    if (e && *e) {
        sprintf(f, "%s.%s", n, e);
    }
    else {
        sprintf(f, "%s", n);
    }
}

FILE *opfi(char *name, char *mode, char *filext)
{
    char filnam[200];
    FILE *fd;

    getfname(filnam, name, filext);

    fd = fopen(filnam, mode);
    if (!fd) {
        printf("\n  Can't Open File: %s\n\n", filnam);
    }
    return fd;
}

/* end */
